//
//  Xe[^XNo.23 - MISSION[h ZNg
//
void statMissionSelect(int player) {
	padRepeat(player);
	padRepeat2(player);
	
	printFont(15 + 24 * player - 12 * maxPlay, 5, "START!", (vslevel[0] == 0) * count % 9);
	if(rots[player] == 0) sprintf(string[0], "TGM");
	else if(rots[player] == 1) sprintf(string[0], "TI");
	else if(rots[player] == 2) sprintf(string[0], "WORLD");
	else if(rots[player] == 3) sprintf(string[0], "WORLD2");
	else if(rots[player] == 4) sprintf(string[0], "ARS");
	else if(rots[player] == 5) sprintf(string[0], "ARS2");
	else if(rots[player] == 6) sprintf(string[0], "WORLD3");
	printFont(15 + 24 * player - 12 * maxPlay, 6, string[0], (vslevel[0] == 0) * count % 9);
	
	printFont(15 + 24 * player - 12 * maxPlay, 8, "EDIT", fontc[rots[player]]);
	sprintf(string[0], "NO.%02d", c_mission);
	printFont(15 + 24 * player - 12 * maxPlay, 9, string[0], (vslevel[0] == 1) * count % 9 );
	
	printFont(15 + 24 * player - 12 * maxPlay, 11, "FILE", fontc[rots[player]]);
	sprintf(string[0], "NO.%02d", mission_file);
	printFont(15 + 24 * player - 12 * maxPlay, 12, string[0], (vslevel[0] == 2) * count % 9 );
	
	printFont(15 + 24 * player - 12 * maxPlay, 14, "LOAD", (vslevel[0] == 3) * count % 9);
	
	printFont(15 + 24 * player - 12 * maxPlay, 16, "SAVE", (vslevel[0] == 4) * count % 9);
	
	// 
	if( (mpc2[player] == 1) || ((mpc2[player] > tame3) && (mpc2[player] % tame4 == 0)) )
	if( getPressState(player, 0) ) {
		PlayWave(5);
		vslevel[0]--;
		if(vslevel[0] < 0) vslevel[0] = 4;
	}
	
	// 
	if( (mpc2[player] == 1) || ((mpc2[player] > tame3) && (mpc2[player] % tame4 == 0)) )
	if( getPressState(player, 1) ) {
		PlayWave(5);
		vslevel[0]++;
		if(vslevel[0] > 4) vslevel[0] = 0;
	}
	
	// 
	if((mpc[player] == 1) || ((mpc[player] > tame1) && (mpc[player] % tame2 == 0)) || (getPressState(player, 6)))
	if( getPressState(player, 2) ) {
		PlayWave(3);
		
		if(vslevel[0] == 0) {
			rots[player]--;
			if(rots[player] < 0) rots[player] = 6;
			setNextBlockColors(player, 1);
		}
		if(vslevel[0] == 1) {
			c_mission--;
			if(c_mission < 0) c_mission = 29;
		}
		if(vslevel[0] == 2) {
			mission_file--;
			if(mission_file < 0) mission_file = 99;
			loadMissionData(mission_file);
		}
	}
	
	// 
	if((mpc[player] == 1) || ((mpc[player] > tame1) && (mpc[player] % tame2 == 0)) || (getPressState(player, 6)))
	if( getPressState(player, 3) ) {
		PlayWave(3);
		
		if(vslevel[0] == 0) {
			rots[player]++;
			if(rots[player] > 6) rots[player] = 0;
			setNextBlockColors(player, 1);
		}
		if(vslevel[0] == 1) {
			c_mission++;
			if(c_mission > 29) c_mission = 0;
		}
		if(vslevel[0] == 2) {
			mission_file++;
			if(mission_file > 99) mission_file = 0;
			loadMissionData(mission_file);
		}
	}
	
	// B{^
	if( getPushState(player, 5) ) {
		gameMode[0] = 0;
		vslevel[0] = 0;
		flag = 1;	// ^Cg
	}
	
	// A{^
	if( getPushState(player, 4) ) {
		PlayWave(10);
		
		if(vslevel[0] == 0) {
			// START!
			stat[player] = 3;
			missionSetStatus();
		}
		if(vslevel[0] == 1) {
			// EDIT
			stat[player] = 24;
		}
		if(vslevel[0] == 3) {
			// LOAD
			loadMissionData(mission_file);
		}
		if(vslevel[0] == 4) {
			// SAVE
			saveMissionData(mission_file);
		}
	}
}

//
//  Xe[^XNo.24 - MISSION[h GfBbg
//
void statMissionEditor(int player) {
	padRepeat(player);
	padRepeat2(player);
	
	// ̎
	printFont(15 + 24 * player - 12 * maxPlay, 5, "TYPE", fontc[rots[player]]);
	if(mission_type[c_mission] == 0) {
		sprintf(string[0], "LEVEL STAR");
	} else if(mission_type[c_mission] == 1) {
		sprintf(string[0], "BIG");
	} else if(mission_type[c_mission] == 2) {
		sprintf(string[0], "DOUBLE");
	} else if(mission_type[c_mission] == 3) {
		sprintf(string[0], "TRIPLE");
	} else if(mission_type[c_mission] == 4) {
		sprintf(string[0], "HEBORIS");
	} else if(mission_type[c_mission] == 5) {
		sprintf(string[0], "CYCLE");
	} else if(mission_type[c_mission] == 6) {
		sprintf(string[0], "TARGET");
	} else if(mission_type[c_mission] == 7) {
		sprintf(string[0], "ERASER");
	} else if(mission_type[c_mission] == 8) {
		sprintf(string[0], "HI-SPEED 1");
	} else if(mission_type[c_mission] == 9) {
		sprintf(string[0], "HI-SPEED 2");
	} else if(mission_type[c_mission] == 10) {
		sprintf(string[0], "ANOTHER");
	} else if(mission_type[c_mission] == 11) {
		sprintf(string[0], "SINGLE");
	} else if(mission_type[c_mission] == 12) {
		sprintf(string[0], "X-RAY");
	} else if(mission_type[c_mission] == 13) {
		sprintf(string[0], "COLOR");
	} else if(mission_type[c_mission] == 14) {
		sprintf(string[0], "ROLL ROLL");
	} else if(mission_type[c_mission] == 15) {
		sprintf(string[0], "MIRROR");
	}
	printFont(15 + 24 * player - 12 * maxPlay, 6, string[0], (statc[0 + player * 10] == 0) * count % 9);
	
	// m}
	printFont(15 + 24 * player - 12 * maxPlay, 7, "NORM", fontc[rots[player]]);
	sprintf(string[0], "%d", mission_norm[c_mission]);
	printFont(15 + 24 * player - 12 * maxPlay, 8, string[0], (statc[0 + player * 10] == 1) * count % 9);
	
	// 
	printFont(15 + 24 * player - 12 * maxPlay, 9, "TIME", fontc[rots[player]]);
	getTime(mission_time[c_mission]);
	printFont(15 + 24 * player - 12 * maxPlay, 10, string[0], (statc[0 + player * 10] == 2) * count % 9);
	
	// x
	printFont(15 + 24 * player - 12 * maxPlay, 11, "LEVEL", fontc[rots[player]]);
	sprintf(string[0], "%d", mission_lv[c_mission] + 1);
	printFont(15 + 24 * player - 12 * maxPlay, 12, string[0], (statc[0 + player * 10] == 3) * count % 9);
	
	// GfBO
	printFont(15 + 24 * player - 12 * maxPlay, 13, "ENDING", fontc[rots[player]]);
	if(mission_end[c_mission] == 0) {
		sprintf(string[0], "NO");
	} else if(mission_end[c_mission] == 1) {
		sprintf(string[0], "END");
	} else if(mission_end[c_mission] == 2) {
		sprintf(string[0], "EXTRA");
	}
	printFont(15 + 24 * player - 12 * maxPlay, 14, string[0], (statc[0 + player * 10] == 4) * count % 9);
	
	// C
	printFont(15 + 24 * player - 12 * maxPlay, 15, "ERASE LINE", fontc[rots[player]]);
	sprintf(string[0], "%d", mission_erase[c_mission]);
	printFont(15 + 24 * player - 12 * maxPlay, 16, string[0], (statc[0 + player * 10] == 5) * count % 9);
	
	// ǉ
	printFont(15 + 24 * player - 12 * maxPlay, 17, "OPTIONS", fontc[rots[player]]);
	sprintf(string[0], "MIN:%d", mission_opt_1[c_mission]);
	printFont(15 + 24 * player - 12 * maxPlay, 18, string[0], (statc[0 + player * 10] == 6) * count % 9);
	sprintf(string[0], "MAX:%d", mission_opt_2[c_mission]);
	printFont(15 + 24 * player - 12 * maxPlay, 19, string[0], (statc[0 + player * 10] == 7) * count % 9);
	sprintf(string[0], "OPT:%d", mission_opt_3[c_mission]);
	printFont(15 + 24 * player - 12 * maxPlay, 20, string[0], (statc[0 + player * 10] == 8) * count % 9);
	
	// 
	if( (mpc2[player] == 1) || ((mpc2[player] > tame3) && (mpc2[player] % tame4 == 0)) )
	if( getPressState(player, 0) ) {
		PlayWave(5);
		statc[0 + player * 10]--;
		if(statc[0 + player * 10] < 0) statc[0 + player * 10] = 8;
	}
	
	// 
	if( (mpc2[player] == 1) || ((mpc2[player] > tame3) && (mpc2[player] % tame4 == 0)) )
	if( getPressState(player, 1) ) {
		PlayWave(5);
		statc[0 + player * 10]++;
		if(statc[0 + player * 10] > 8) statc[0 + player * 10] = 0;
	}
	
	// 
	if((mpc[player] == 1) || ((mpc[player] > tame1) && (mpc[player] % tame2 == 0)) || (getPressState(player, 6)))
	if( getPressState(player, 2) ) {
		PlayWave(3);
		
		// TYPE
		if(statc[0 + player * 10] == 0) {
			mission_type[c_mission]--;
			if(mission_type[c_mission] < 0) mission_type[c_mission] = 15;
		}
		// NORM
		if(statc[0 + player * 10] == 1) {
			mission_norm[c_mission]--;
			if(mission_norm[c_mission] < 0) mission_norm[c_mission] = 99;
		}
		// TIME
		if(statc[0 + player * 10] == 2) {
			mission_time[c_mission] = mission_time[c_mission] - 60;
			if(mission_time[c_mission] < 0) mission_time[c_mission] = 60 * 60 * 20;
		}
		// LEVEL
		if(statc[0 + player * 10] == 3) {
			mission_lv[c_mission]--;
			if(mission_lv[c_mission] < 0) mission_lv[c_mission] = 14;
		}
		// ENDING
		if(statc[0 + player * 10] == 4) {
			mission_end[c_mission]--;
			if(mission_end[c_mission] < 0) mission_end[c_mission] = 2;
		}
		// ERASE LINE
		if(statc[0 + player * 10] == 5) {
			mission_erase[c_mission]--;
			if(mission_erase[c_mission] < 0) mission_erase[c_mission] = 21;
		}
		// OPTIONS
		if(statc[0 + player * 10] == 6) {
			mission_opt_1[c_mission]--;
			if(mission_opt_1[c_mission] < 0) mission_opt_1[c_mission] = 99;
		}
		if(statc[0 + player * 10] == 7) {
			mission_opt_2[c_mission]--;
			if(mission_opt_2[c_mission] < 0) mission_opt_2[c_mission] = 99;
		}
		if(statc[0 + player * 10] == 8) {
			mission_opt_3[c_mission]--;
			if(mission_opt_3[c_mission] < 0) mission_opt_3[c_mission] = 99;
		}
	}
	
	// 
	if((mpc[player] == 1) || ((mpc[player] > tame1) && (mpc[player] % tame2 == 0)) || (getPressState(player, 6)))
	if( getPressState(player, 3) ) {
		PlayWave(3);
		
		// TYPE
		if(statc[0 + player * 10] == 0) {
			mission_type[c_mission]++;
			if(mission_type[c_mission] > 15) mission_type[c_mission] = 0;
		}
		// NORM
		if(statc[0 + player * 10] == 1) {
			mission_norm[c_mission]++;
			if(mission_norm[c_mission] > 99) mission_norm[c_mission] = 0;
		}
		// TIME
		if(statc[0 + player * 10] == 2) {
			mission_time[c_mission] = mission_time[c_mission] + 60;
			if(mission_time[c_mission] > 60 * 60 * 20) mission_time[c_mission] = 0;
		}
		// LEVEL
		if(statc[0 + player * 10] == 3) {
			mission_lv[c_mission]++;
			if(mission_lv[c_mission] > 14) mission_lv[c_mission] = 0;
		}
		// ENDING
		if(statc[0 + player * 10] == 4) {
			mission_end[c_mission]++;
			if(mission_end[c_mission] > 2) mission_end[c_mission] = 0;
		}
		// ERASE LINE
		if(statc[0 + player * 10] == 5) {
			mission_erase[c_mission]++;
			if(mission_erase[c_mission] > 21) mission_erase[c_mission] = 0;
		}
		// OPTIONS
		if(statc[0 + player * 10] == 6) {
			mission_opt_1[c_mission]++;
			if(mission_opt_1[c_mission] > 99) mission_opt_1[c_mission] = 0;
		}
		if(statc[0 + player * 10] == 7) {
			mission_opt_2[c_mission]++;
			if(mission_opt_2[c_mission] > 99) mission_opt_2[c_mission] = 0;
		}
		if(statc[0 + player * 10] == 8) {
			mission_opt_3[c_mission]++;
			if(mission_opt_3[c_mission] > 99) mission_opt_3[c_mission] = 0;
		}
	}
	
	// A܂B{^
	if( getPushState(player, 4) || getPushState(player, 5) ) {
		stat[player] = 23;	// ZNgʂɖ߂
		statc[0 + player * 10] = 0;
	}
}

//
//  ̕\
//
void viewMission() {
	int i;
	
	// BltFastRect(v[io[,dx,dy,sx,sy,hx,hy);
	
	// g
	if(screenMode <= 1) {
		BltFastRect(44, 208 * maxPlay, 112, 288, 368, 112, 112);
	} else {
		BltFastRect(44, 16 + maxPlay * 400, 224, 448, 288, 192, 192);
	}
	
	// ̎
	if(screenMode <= 1) {
		TextLayerOn(0, 6 + 208 * maxPlay, 8 + 112);
		TextSize(0, 10);
	} else {
		TextLayerOn(0, 10 + 16 + maxPlay * 400, 8 + 228);
		TextSize(0, 16);
	}
	TextColor(0, 0, 0, 0);
	TextBackColorDisable(0);
	
	getMissionName(mission_type[c_mission]);
	
	// xx
	sprintf(string[70], " LV%02d", mission_lv[c_mission] + 1);
	strcat(string[0], string[70]);
	
	// `
	TextOut(0, string[0]);
	TextBlt(0);
	
	// 
	if(screenMode <= 1) {
		TextMove(0, 6 + 208 * maxPlay, 30 + 112);
	} else {
		TextMove(0, 10 + 16 + maxPlay * 400, 30 + 228);
	}
	
	if(!english) strcpy(string[70], " ");
	else strcpy(string[70], "Time ");
	
	getTime(mission_time[c_mission]);
	strcat(string[70], string[0]);
	
	// `
	TextOut(0, string[70]);
	TextBlt(0);
	
	// wߕ
	if(screenMode <= 1) {
		TextMove(0, 6 + 208 * maxPlay, 52 + 112);
	} else {
		TextMove(0, 10 + 16 + maxPlay * 400, 52 + 228);
	}
	
	if(!english) {
		if( (mission_type[c_mission] == 0) || (mission_type[c_mission] == 1) || (mission_type[c_mission] == 7) || 
		    (mission_type[c_mission] == 8) || (mission_type[c_mission] == 9) || (mission_type[c_mission] == 10) ||
		    (mission_type[c_mission] == 12) || (mission_type[c_mission] == 13) || (mission_type[c_mission] == 14) || 
		    (mission_type[c_mission] == 15) )
		{
			sprintf(string[0], "%dCI", mission_norm[c_mission]);
		} else if(mission_type[c_mission] == 2) {
			sprintf(string[0], "%d_u߂I", mission_norm[c_mission]);
		} else if(mission_type[c_mission] == 3) {
			sprintf(string[0], "%dgv߂I", mission_norm[c_mission]);
		} else if(mission_type[c_mission] == 4) {
			sprintf(string[0], "%dw{X߂I", mission_norm[c_mission]);
		} else if(mission_type[c_mission] == 5) {
			sprintf(string[0], "TCN߂I");
		} else if(mission_type[c_mission] == 6) {
			sprintf(string[0], "%dXe[WNAI", mission_norm[c_mission]);
		} else if(mission_type[c_mission] == 11) {
			sprintf(string[0], "%dVO߂I", mission_norm[c_mission]);
		}
	} else {
		if( (mission_type[c_mission] == 0) || (mission_type[c_mission] == 1) || (mission_type[c_mission] == 7) || 
		    (mission_type[c_mission] == 8) || (mission_type[c_mission] == 9) || (mission_type[c_mission] == 10) ||
		    (mission_type[c_mission] == 12) || (mission_type[c_mission] == 13) || (mission_type[c_mission] == 14) || 
		    (mission_type[c_mission] == 15) )
		{
			sprintf(string[0], "Erase %d lines!", mission_norm[c_mission]);
		} else if(mission_type[c_mission] == 2) {
			sprintf(string[0], "Erase 2 lines at once\n%d times!", mission_norm[c_mission]);
		} else if(mission_type[c_mission] == 3) {
			sprintf(string[0], "Erase 3 lines at once\n%d times!", mission_norm[c_mission]);
		} else if(mission_type[c_mission] == 4) {
			sprintf(string[0], "Erase 4 lines at once\n%d times!", mission_norm[c_mission]);
		} else if(mission_type[c_mission] == 5) {
			sprintf(string[0], "Do cycle!");
		} else if(mission_type[c_mission] == 6) {
			sprintf(string[0], "Clear %d stages!", mission_norm[c_mission]);
		} else if(mission_type[c_mission] == 11) {
			sprintf(string[0], "Erase 1 line only\n%d times!", mission_norm[c_mission]);
		}
	}
	
	// `
	TextOut(0, string[0]);
	TextBlt(0);
	
	// gpI
	TextLayerOff(0);
	
	// ~bVꗗ
	for(i = 0; i < 5; i++) {
		if(screenMode <= 1) {
			BltFastRect(44, 208 * maxPlay, 32 + i * 16, 288, 304 + ((c_mission > i) || (ending[0] != 0)) * 32, 112, 16);
			TextLayerOn(0, 1 + 208 * maxPlay, 1 + 32 + i * 16);
			TextSize(0, 10);
		} else {
			BltFastRect(44, 16 + maxPlay * 400, 64 + i * 32, 448, 224 + ((c_mission > i) || (ending[0] != 0)) * 32, 160, 16);
			TextLayerOn(0, 1 + 16 + maxPlay * 400, 1 + 64 + i * 32);
			TextSize(0, 14);
		}
		TextColor(0, 0, 0, 0);
		TextBackColorDisable(0);
		
		getMissionName(mission_type[i]);
		
		// `
		TextOut(0, string[0]);
		TextBlt(0);
		
		// gpI
		TextLayerOff(0);
		
		// ItOꍇ͂Ń[v𔲂
		if(mission_end[i]) break;
	}
}

// ~bV擾
void getMissionName(int mtype) {
	if(!english) {
		if(mtype == 0) {
			strcpy(string[0], "xX^[");
		} else if(mtype == 1) {
			strcpy(string[0], "rbO");
		} else if(mtype == 2) {
			strcpy(string[0], "_u");
		} else if(mtype == 3) {
			strcpy(string[0], "gv");
		} else if(mtype == 4) {
			strcpy(string[0], "w{X");
		} else if(mtype == 5) {
			strcpy(string[0], "TCN");
		} else if(mtype == 6) {
			strcpy(string[0], "^[Qbg");
		} else if(mtype == 7) {
			strcpy(string[0], "CCT[");
		} else if(mtype == 8) {
			strcpy(string[0], "nCXs[hP");
		} else if(mtype == 9) {
			strcpy(string[0], "nCXs[hQ");
		} else if(mtype == 10) {
			strcpy(string[0], "AiU[");
		} else if(mtype == 11) {
			strcpy(string[0], "VO");
		} else if(mtype == 12) {
			strcpy(string[0], "X-RAY");
		} else if(mtype == 13) {
			strcpy(string[0], "J[");
		} else if(mtype == 14) {
			strcpy(string[0], "[[");
		} else if(mtype == 15) {
			strcpy(string[0], "~[");
		}
	} else {
		if(mtype == 0) {
			strcpy(string[0], "Level star");
		} else if(mtype == 1) {
			strcpy(string[0], "Big");
		} else if(mtype == 2) {
			strcpy(string[0], "Double");
		} else if(mtype == 3) {
			strcpy(string[0], "Triple");
		} else if(mtype == 4) {
			strcpy(string[0], "Heboris");
		} else if(mtype == 5) {
			strcpy(string[0], "Cycle");
		} else if(mtype == 6) {
			strcpy(string[0], "Target");
		} else if(mtype == 7) {
			strcpy(string[0], "Eraser");
		} else if(mtype == 8) {
			strcpy(string[0], "Hi-Speed 1");
		} else if(mtype == 9) {
			strcpy(string[0], "Hi-Speed 2");
		} else if(mtype == 10) {
			strcpy(string[0], "Another");
		} else if(mtype == 11) {
			strcpy(string[0], "Single");
		} else if(mtype == 12) {
			strcpy(string[0], "X-Ray");
		} else if(mtype == 13) {
			strcpy(string[0], "Color");
		} else if(mtype == 14) {
			strcpy(string[0], "Roll Roll");
		} else if(mtype == 15) {
			strcpy(string[0], "Mirror");
		}
	}
}

/* ~bV[h̃m}㏸ */
void missionNormUp(int lines) {
	int i, j;
	int by2, tmp;
	
	// xX^[nirbOHS1&2AiU[X-RAYJ[E[[E~[j
	if( (mission_type[c_mission] == 0) || (mission_type[c_mission] == 1) || (mission_type[c_mission] == 8) ||
		(mission_type[c_mission] == 9) || (mission_type[c_mission] == 10) ||
		(mission_type[c_mission] == 12) || (mission_type[c_mission] == 13) || (mission_type[c_mission] == 14) ||
		(mission_type[c_mission] == 15) )
	{
		c_norm = c_norm + lines;
	}
	
	// _u
	if( mission_type[c_mission] == 2 ) {
		if(lines == 2) c_norm++;
	}
	
	// gv
	if( mission_type[c_mission] == 3 ) {
		if(lines == 3) c_norm++;
	}
	
	// w{X
	if( mission_type[c_mission] == 4 ) {
		if(lines == 4) c_norm++;
	}
	
	// TCN
	if( mission_type[c_mission] == 5 ) {
		if(!cycle[lines - 1]) {
			cycle[lines - 1] = 1;
			c_norm++;
		}
	}
	
	// ^[Qbg
	if( mission_type[c_mission] == 6 ) {
		// v`iubN0
		if(getPlatinumBlock(0) == 0) {
			PlayWave(31);
			c_norm++;
			
			// ̃Xe[W
			if(c_norm < mission_norm[c_mission]) {
				timeOn[0] = 0;
				
				for(i = 0; i < 21; i++) erase[i] = 1;
				
				stat[0] = 25;	// SC
				statc[0] = 0;
				statc[1] = 3;	// Ready
				statc[2] = 1;	// Xe[Wǂݍ݂
			}
		}
	}
	
	// CCT[
	if( mission_type[c_mission] == 7 ) {
		for(i = 0; i < 4; i++) {
			// ׂYW߂
			if( isWRule(0) ) {
				by2 = (by[0] + blkWDataY[blk[0] * 16 + rt[0] * 4 + i]);
			} else {
				by2 = (by[0] + blkDataY[blk[0] * 16 + rt[0] * 4 + i]);
			}
			
			// ׂCׂ
			for(j = 0; j < eraser_now_lines; j++) {
				if(j >= 4) break;
				
				if( (by2 == eraser_lines[j]) && (erase[by2]) && (!eraser_cleared[j]) ) {
					eraser_cleared[j] = 1;
					c_norm++;
				}
			}
		}
		
		// SĂ̂Ƀm}BĂȂꍇ͐Vȃp^[o
		if(c_norm < mission_norm[c_mission]) {
			tmp = 1;
			
			for(i = 0; i < eraser_now_lines; i++) {
				if(i >= 4) break;
				
				if(!eraser_cleared[i]) {
					tmp = 0;
					break;
				}
			}
			
			if(tmp) {
				setEraserLines();
			}
		}
	}
	
	// VO
	if( mission_type[c_mission] == 11 ) {
		if(lines == 1) c_norm++;
	}
	
	// ~bVNA
	if(c_norm >= mission_norm[c_mission]) {
		PlayWave(19);
		StopWave(32);
		
		timeOn[0] = 0;
		c_mission++;
		clear_mission++;
		
		// GfBO˓`FbN
		if((c_mission > 29) || (mission_end[c_mission - 1] == 1) || ((mission_end[c_mission - 1] == 2) && (lines != 2))) {
			c_mission = c_mission - 1;
			c_norm = mission_norm[c_mission];
			ending[0] = 1;
			pinch[0] = 0;
			onRecord[0] = 0;
			pinch[0] = 0;
		} else {
			missionSetStatus();
		}
	}
}

/* ̐ݒixetcjQ[ɔf */
void missionSetStatus() {
	int i;
	int tmp;
	
	// m}
	c_norm = 0;
	
	// rbO
	if(mission_type[c_mission] == 1) {
		IsBig[0] = 1;
	} else {
		IsBig[0] = 0;
	}
	Biginit(0);
	
	// ^C
	ltime[0] = mission_time[c_mission];
	
	// x
	lv[0] = mission_lv[c_mission] + 1;
	
	backno = mission_lv[c_mission];
	if(backno > bg_max) backno = bg_max;
	
	// x
	if(mission_type[c_mission] <= 7) {
		// ʏ
		sp[0] = lvTableAce[mission_lv[c_mission]];
		wait1[0] = wait1_Ace;
		wait2[0] = wait2_Ace;
		wait3[0] = wait3_Ace;
		waitt[0] = waitt_Ace;
	} else if(mission_type[c_mission] == 8) {
		// nCXs[hP
		sp[0] = lvTableHiSpeed1[mission_lv[c_mission]];
		wait1[0] = wait1_HiSpeed1;
		wait2[0] = wait2_HiSpeed1;
		wait3[0] = wait3_HiSpeed1;
		waitt[0] = waitt_HiSpeed1;
	} else if(mission_type[c_mission] == 9) {
		// nCXs[hQ
		sp[0] = 1200;
		wait1[0] = wait1_HiSpeed2;
		wait2[0] = wait2_HiSpeed2;
		wait3[0] = wait3_HiSpeed2;
		waitt[0] = waitt_HiSpeed2;
	} else if(mission_type[c_mission] == 10) {
		// AiU[
		sp[0] = 1200;
		wait1[0] = wait1_Acea_tbl[mission_lv[c_mission]];
		wait2[0] = wait2_Acea_tbl[mission_lv[c_mission]];
		wait3[0] = wait3_Acea_tbl[mission_lv[c_mission]];
		waitt[0] = waitt_Acea_tbl[mission_lv[c_mission]];
	} else if(mission_type[c_mission] >= 8) {
		// X-RAYȍ~BeLg[
		sp[0] = lvTableAce[mission_lv[c_mission]];
		wait1[0] = wait1_Ace;
		wait2[0] = wait2_Ace;
		wait3[0] = wait3_Ace;
		waitt[0] = waitt_Ace;
	}
	
	// TCNptO
	if(mission_type[c_mission] == 5) {
		for(i = 0; i < 4; i++) cycle[i] = 0;
	}
	
	// ^[Qbgp
	if(mission_type[c_mission] == 6) {
		for(i = 0; i < 27; i++) target_cleared[i] = 0;
	}
	
	// CCT[p
	if(mission_type[c_mission] == 7) {
		setEraserLines();
	}
	// X-RAYp
	if(mission_type[c_mission] == 12) {
		isxray[0] = 1;
		xray_flag[0] = 1;
		//p_xray_interval = 1;
		xray_counter[0] = 0;
	} else {
		isxray[0] = 0;
		xray_flag[0] = 0;
	}
	
	// J[p
	if(mission_type[c_mission] == 13) {
		iscolor[0] = 1;
		color_flag[0] = 1;
	} else {
		iscolor[0] = 0;
		color_flag[0] = 0;
	}
	
	// [[p
	if(mission_type[c_mission] == 14) {
		item_rollroll[0] = 1;
		isrollroll[0] = 1;
	} else {
		item_rollroll[0] = 0;
		isrollroll[0] = 0;
	}
	
	// ~[p
	if(mission_type[c_mission] == 15) {
		isfmirror[0] = 1;
	} else {
		isfmirror[0] = 0;
	}
}

// tB[h̍ŏiԂ
int checkFieldTop(int player) {
	int i, j;
	
	for(i = 0; i <= fldsizeh[player]; i++)
		for(j = 0; j < fldsizew[player]; j++) 
			if(fld[j + i * fldsizew[player] + player * 210])
				return i;
	
	// ۂ̏ꍇ
	return 21;
}

// CCT[p
void setEraserLines() {
	int i, tmp;
	int line[21];	// C̏dh~p
	
	for(i = 0; i < 21; i++) line[i] = 0;
	
	eraser_now_lines = 0;
	
	for(i = 0; i <= mission_opt_3[c_mission]; i++) {
		if(i >= 4) break;	// ő4{܂
		if(i >= mission_norm[c_mission] - c_norm) break;
		
		eraser_now_lines++;
		
		do {
			tmp = Rand(21);
		} while( (tmp < mission_opt_1[c_mission]) || (tmp > mission_opt_2[c_mission]) || (line[tmp] == 1) );
		
		line[tmp] = 1;
		eraser_lines[i] = tmp;
		eraser_cleared[i] = 0;
	}
}

// CCT[̐\
void viewEraserLines() {
	int i;
	
	if( (!timeOn[0]) || (mission_type[c_mission] != 7) ) return;
	
	for(i = 0; i < eraser_now_lines; i++) {
		if(i >= 4) break;	// ő4{܂
		
		if(screenMode <= 1)
			BltRect(44, 2 + (14 - 12 * maxPlay) * 8, (eraser_lines[i] + 4) * 8, 290, 256 + eraser_cleared[i] * 32, 92, 8);
		else
			BltRect(44, 4 + (14 - 12 * maxPlay) * 16, (eraser_lines[i] + 4) * 16, 451, 160 + eraser_cleared[i] * 32, 184, 16);
	}
}

// ^[Qbgł̃Xe[Wǂݍ
void loadTargetStage() {
	int tmp;
	
	// ǉŏoXe[W͈̔͂w\ #1.60c7s2
	do {
		tmp = Rand(100);
	} while( (tmp < mission_opt_1[c_mission]) || (tmp > mission_opt_2[c_mission]) || (target_cleared[tmp] == 1) );
	
	target_cleared[tmp] = 1;	// oς݃tOON
	loadTomoyoStage(0, tmp);
}

//
//  f[^̓ǂݍ݁^ۑ
//
// t@CtH[}bg (4byteP)
//   0       o[W (0= 1=c7r8)
//   1`  19 gp
//  20`  39 P
//  40`  59 Q

/* [h */
void loadMissionData(int number) {
	int i;
	
	FillMemory(&saveBuf, 50000 * 4, 0);
	
	sprintf(string[0], "stage/mission%02d.sav", number);
	
	LoadFile(string[0], &saveBuf, 420 * 4);
	
	// f[^ǂݍ
	for(i = 0; i < 30; i++) {
		mission_type[i]  = saveBuf[(i + 1) * 20 + 0];	// 
		mission_norm[i]  = saveBuf[(i + 1) * 20 + 1];	// m}
		mission_time[i]  = saveBuf[(i + 1) * 20 + 2];	// 
		mission_end[i]   = saveBuf[(i + 1) * 20 + 3];	// ItO
		mission_lv[i]    = saveBuf[(i + 1) * 20 + 4];	// x
		mission_erase[i] = saveBuf[(i + 1) * 20 + 5];	// NAɏォ郉C
		mission_opt_1[i] = saveBuf[(i + 1) * 20 + 6];	// ǉPij
		mission_opt_2[i] = saveBuf[(i + 1) * 20 + 7];	// ǉQij
		mission_opt_3[i] = saveBuf[(i + 1) * 20 + 8];	// ǉRiCCT[Ɩ{A͖gpj
	}
}

/* Z[u */
void saveMissionData(int number) {
	int i;
	
	FillMemory(&saveBuf, 50000 * 4, 0);
	
	// wb_
	saveBuf[0] = 1;
	
	// f[^
	for(i = 0; i < 30; i++) {
		saveBuf[(i + 1) * 20 + 0] = mission_type[i];	// 
		saveBuf[(i + 1) * 20 + 1] = mission_norm[i];	// m}
		saveBuf[(i + 1) * 20 + 2] = mission_time[i];	// 
		saveBuf[(i + 1) * 20 + 3] = mission_end[i];		// ItO
		saveBuf[(i + 1) * 20 + 4] = mission_lv[i];		// x
		saveBuf[(i + 1) * 20 + 5] = mission_erase[i];	// NAɏォ郉C
		saveBuf[(i + 1) * 20 + 6] = mission_opt_1[i];	// ǉP
		saveBuf[(i + 1) * 20 + 7] = mission_opt_2[i];	// ǉQ
		saveBuf[(i + 1) * 20 + 8] = mission_opt_3[i];	// ǉR
	}
	
	sprintf(string[0], "stage/mission%02d.sav", number);
	SaveFile(string[0], &saveBuf, 420 * 4);
}
